﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CatBodySpawner : MonoBehaviour {

    public float launchMinimumSpeed = 4.0f;
    private float curSpeed = 0.0f;
	// Use this for initialization
	void Start () 
    {
	}

    void SpawnBody()
    {
        float throwAngle = 45.0f;
        Vector3 angleVec = new Vector2(-(float)Mathf.Cos(Mathf.Deg2Rad * throwAngle), (float)Mathf.Sin(Mathf.Deg2Rad * throwAngle));

        if (transform.GetComponentInParent<CharacterController2D>().velocity.x > 0)
        {
            angleVec.x *= -1;
        }

        GameObject temp = UnityEngine.Object.Instantiate(Resources.Load("CatTest"), transform.parent.position + angleVec * 1.0f, Quaternion.identity) as GameObject;
        GameManager.CatCount -= 1;        
        List<Rigidbody2D> list = new List<Rigidbody2D>(temp.GetComponentsInChildren<Rigidbody2D>());
        for (int i = 0; i < list.Count; i++)
        {
            Vector2 force = transform.GetComponentInParent<Rigidbody2D>().mass * angleVec * 1.0f;
            list[i].AddForce(transform.GetComponentInParent<CharacterController2D>().velocity * 100.0f);
        }

        Debug.Log("destroy Catbodyspawner");
        Destroy(this.transform.parent.gameObject);
        
    }
	// Update is called once per frame
	void Update () 
    {
        curSpeed = this.GetComponentInParent<CharacterController2D>().velocity.x;
        //Is able to do spawning of cat body if move faster then deathspeed. Meow
        if (curSpeed > launchMinimumSpeed && Input.GetKeyDown(KeyCode.Space))
        {
            SpawnBody();
        }
        
	}
}
